/**
 * Cnsq.java Version 32g 6-Nov-1998
 * Copyright (c) 1997-2000 Kyushu University
 *
 * Updated 99-09-08
 * putBuf and putUnitBuf revised to
 * suppress generating new ULists
 *
 * pdlnF, mdlnF, ndlnF  deleted  21-Feb-2000
 **/

/*
 * Cnsq
 *  +--FalseCnsq
 *  +--PCnsq
 *  +--NCnsq
 *  +--MCnsq
 *  +--GPCnsq
 *  +--GNCnsq
 *  +--GMCnsq
 *  +--Disj (abstract)
 *  |   +--PDisj
 *  |   +--NDisj
 *  |   +--MDisj
 *  |   +--GPDisj
 *  |   +--GNDisj
 *  |   +--GMDisj
 *  +--Conj
 *  |   +--GConj
 *  |   +--Unit
 *  |   |   +--GUnit
 *  |   +--DomConj
 *  |       +--GDomConj
 *  +--CLCnsq
 *  +--SLCnsq
 */

package mgtp;

public class Cnsq {
  int dn; Term hd; Cnsq tl;
  Cnsq() {}
  Cnsq(int i, Term t) {dn=i; hd=t;}
  Cnsq(int i, Term t, Cnsq c) {dn=i; hd=t; tl=c;}

  public String toString() {
    return "Cnsq:"+hd+clist(hd)+
      //      ":"+hd.satisfied()+ // ### debug
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  // %%% PTV
  public int length() {
    int i=0;
    int cdn= -1;
    Cnsq tgt=this;
    if ((this instanceof GPDisj)||(this instanceof GNDisj)||
       (this instanceof GMDisj)){
      while (tgt!=null) {
	i++;cdn=tgt.dn;
	tgt=tgt.tl;
      }
    }
    else {
      while (tgt!=null) {
	if (cdn!=tgt.dn) {i++;cdn=tgt.dn;}
	tgt=tgt.tl;
      }    
    }
    return i;
  }
  // %%%

  public static String clist(Term t) {
    String s="[";

    if (t instanceof GTerm) {
      GTerm gt=(GTerm)t;
      s+=""+gt.Cls.listID();
    } 
    else if (t instanceof CTermF) {
      CTermF ct=(CTermF)t;
      if (ct.Cls!=null) s+=""+ct.Cls.listID();
      // when ct is not entry literal (i.e. ct is consequent literal)
      // ct.Cls==null means that ct is CTermF (NCTermF) as an entry literal
    }

    return s+"]";
  }

  Cnsq copy() {
    Cnsq cp=new Cnsq(dn,hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new Cnsq(c.dn,c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) {} // %%% public: PTV
  void putUnitBuf(MGTP mg) {
    Cnsq c=this;
    while (c!=null) {
      //Counter.usubs++;
      if (c.hd.notsubsumed_ac(mg)) {
        //Counter.usubspass++;
        if (mg.unitF==null) mg.unitL=mg.unitF=new UList(c.hd);
        else {mg.unitL.tl=new UList(c.hd); mg.unitL=mg.unitL.tl;}
      }
      c=c.tl;
    }
  }

  Cnsq moveToBuf(int i, MGTP mg) {
    Cnsq d=tl;
    while (d!=null&&i==d.dn) {
      //Counter.usubs++;
      if (d.hd.notsubsumed_ac(mg)) {
        //Counter.usubspass++;
     	if (mg.unitF==null) 
	  mg.unitF=mg.unitL=new UList(d.hd);
        else {
	  mg.unitL.tl=new UList(d.hd);
	  mg.unitL=mg.unitL.tl; 
        }
      }
      d=d.tl;
    }
    return d;
  }

  boolean simplify(DList me, MGTP mg) {
    int dc=0; boolean cc=true; Cnsq f,l,d,rval;
    f=l=d=this; rval=null; 
    while (d!=null) {
      if (cc && d.hd.conflict()) cc=false; // simplified 
      if (d.tl==null || d.dn!=d.tl.dn) { // reaches disjunct boundary
	if (cc) {
	  if (rval==null) rval=f;
	  else if (l.tl!=f) {
	    mg.rjl=new RDjList(l,l.tl,mg.rjl);
	    l.tl=f;
	  }
	  l=d; f=d.tl; dc++;
	} else { f=d.tl; cc=true;}
      }
      d=d.tl;
    }
    if (l.tl!=f && dc!=0) {
      mg.rjl=new RDjList(l,l.tl,mg.rjl);
      l.tl=null;
    }
    me.update(dc,rval,mg);
    return (dc==0);
  }

  Cnsq subsumedDj(MGTP mg) {
    RDjList wdl=RDjList.NIL; boolean cc=false; Cnsq tdhp,d,rval;
    tdhp=this; d=this; rval=null;
    while (d!=null) {
      if (!d.hd.subsumed()) { // not subsumed
	cc=true;
	if (rval==null) rval=d;
	else if (tdhp.tl!=d) wdl=new RDjList(tdhp,d,wdl);
	tdhp=d;
      } 
      if (d.tl==null||d.dn!=d.tl.dn) {
	if (!cc) return null;
	cc=false;
      }
      d=d.tl;
    } 
    if (tdhp.tl!=d) wdl=new RDjList(tdhp,null,wdl);
    if (wdl!=RDjList.NIL) {
      Cnsq tmp; RDjList pw,w; pw=w=wdl;
      while (w!=RDjList.NIL) {
	tmp=w.oldtl; w.oldtl=w.target.tl; w.target.tl=tmp;
	pw=w; w=w.tl;
      }
      pw.tl=mg.rjl; mg.rjl=wdl;
    }
    return rval;
  }

}

class FalseCnsq extends Cnsq {
  FalseCnsq() {}
  public String toString() {return "";}
  public void putBuf(MGTP mg) {mg.closed=true;} // %%% public: PTV
  Cnsq copy() {return this;}
}

class PCnsq extends Cnsq {
  int dsize;
  PCnsq(int i, Term a) {dn=i; hd=a;}
  PCnsq(int i, Term a, Cnsq t) {dn=i; hd=a; tl=t;}
  PCnsq(int i, Term a, Cnsq t, int ds) {dn=i; hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "PCnsq:"+hd+clist(hd)+
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  Cnsq copy() {
    Cnsq cp=new PCnsq(dn,hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new Cnsq(c.dn,c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq t=this;
    Cnsq g=new GPCnsq(dn,t.hd.indexBV(mg));
    Cnsq gh=g; 
    do {
      t=t.tl;
      if (t==null) break;
      g.tl=new GPCnsq(t.dn,t.hd.indexBV(mg));
      g=g.tl;
    } while (true);

    if (mg.pdlF==DList.NIL)
      mg.pdlL=mg.pdlF=new DList(dsize,gh);
    else {
      mg.pdlL.tl=new DList(dsize,gh);
      mg.pdlL=mg.pdlL.tl;
    }
  }
}

class NCnsq extends Cnsq {
  int dsize;
  NCnsq(int i, Term a) {dn=i; hd=a;}
  NCnsq(int i, Term a, Cnsq t) {dn=i; hd=a; tl=t;}
  NCnsq(int i, Term a, Cnsq t, int ds) {dn=i; hd=a; tl=t; dsize=ds;}
  public String toString() {
    return "NCnsq:"+hd+clist(hd)+
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  Cnsq copy() {
    Cnsq cp=new NCnsq(dn,hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new Cnsq(c.dn,c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq t=this;
    Cnsq g=new GNCnsq(dn,t.hd.indexBV(mg));
    Cnsq gh=g;
    do {
      t=t.tl;
      if (t==null) break;
      g.tl=new GNCnsq(t.dn,t.hd.indexBV(mg));
      g=g.tl;
    } while (true);

    if (mg.ndlF==DList.NIL)
      mg.ndlL=mg.ndlF=new DList(dsize,gh);
    else {
      mg.ndlL.tl=new DList(dsize,gh);
      mg.ndlL=mg.ndlL.tl;
    }
  }
}

class MCnsq extends Cnsq {
  int dsize;
  MCnsq(int i, Term a) {dn=i; hd=a;}
  MCnsq(int i, Term a, Cnsq t) {dn=i; hd=a; tl=t;}
  MCnsq(int i, Term a, Cnsq t, int ds) {dn=i; hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "MCnsq:"+hd+clist(hd)+
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  Cnsq copy() {
    Cnsq cp=new MCnsq(dn,hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new Cnsq(c.dn,c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq t=this;
    Cnsq g=new GMCnsq(dn,t.hd.indexBV(mg));
    Cnsq gh=g;
    do {
      t=t.tl;
      if (t==null) break;
      g.tl=new GMCnsq(t.dn,t.hd.indexBV(mg));
      g=g.tl;
    } while (true);

    if (mg.mdlF==DList.NIL)
      mg.mdlL=mg.mdlF=new DList(dsize,gh);
    else {
      mg.mdlL.tl=new DList(dsize,gh);
      mg.mdlL=mg.mdlL.tl;
    }
  }
}

class GPCnsq extends Cnsq {
  int dsize;
  GPCnsq(int i, Term a) {dn=i; hd=a;}
  GPCnsq(int i, GTerm a, Cnsq n) {dn=i; hd=a; tl=n;}
  GPCnsq(int i, GTerm a, Cnsq t, int ds) {dn=i; hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "GPCnsq:"+hd+clist(hd)+
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  Cnsq copy() {return this;}

  public void putBuf(MGTP mg) { // %%% public: PTV
    if (mg.pdlF==DList.NIL)
      mg.pdlL=mg.pdlF=new DList(dsize,this);
    else {
      mg.pdlL.tl=new DList(dsize,this);
      mg.pdlL=mg.pdlL.tl;
    }
  }
}

class GNCnsq extends Cnsq {
  int dsize;
  GNCnsq(int i, Term a) {dn=i; hd=a;}
  GNCnsq(int i, GTerm a, Cnsq n) {dn=i; hd=a; tl=n;} 
  GNCnsq(int i, GTerm a, Cnsq t, int ds) {dn=i; hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "GNCnsq:"+hd+clist(hd)+
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  Cnsq copy() {return this;}

  public void putBuf(MGTP mg) { // %%% public: PTV
    if (mg.ndlF==DList.NIL)
      mg.ndlL=mg.ndlF=new DList(dsize,this);
    else {
      mg.ndlL.tl=new DList(dsize,this);
      mg.ndlL=mg.ndlL.tl;
    }
  }
}

class GMCnsq extends Cnsq {
  int dsize;
  GMCnsq(int i, Term a) {dn=i; hd=a;}
  GMCnsq(int i, GTerm a, Cnsq n) {dn=i; hd=a; tl=n;}
  GMCnsq(int i, GTerm a, Cnsq t, int ds) {dn=i; hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "GMCnsq:"+hd+clist(hd)+
      //    return hd+clist(hd)+
      (tl==null ? "" : (dn==tl.dn ? ", " : "; ")+tl);
  }

  Cnsq copy() {return this;}

  public void putBuf(MGTP mg) { // %%% public: PTV
    if (mg.mdlF==DList.NIL)
      mg.mdlL=mg.mdlF=new DList(dsize,this);
    else {
      mg.mdlL.tl=new DList(dsize,this);
      mg.mdlL=mg.mdlL.tl;
    }
  }
}

abstract class Disj extends Cnsq {
  Disj() {}
  Disj(Term a) {hd=a;}
  Disj(Term a, Cnsq n) {hd=a; tl=n;}

  public String toString() { 
    return "Disj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }
  void putUnitBuf(MGTP mg) {
    //Counter.usubs++;
    if (hd.notsubsumed_ac(mg)) {
      //Counter.usubspass++;
      if (mg.unitF==null) mg.unitL=mg.unitF=new UList(hd);
      else {mg.unitL.tl=new UList(hd); mg.unitL=mg.unitL.tl;}
    }
  }
  Cnsq moveToBuf(int i, MGTP mg) {return tl;}

  boolean simplify(DList me, MGTP mg) {
    int dc=0; Cnsq tdhp,d,rval;
    tdhp=me.disj; d=this; rval=null;
    while (d!=null) {
      if (!d.hd.conflict()) { // not simplified 
        if (rval==null) rval=d;
	else if (tdhp.tl!=d) {
	  mg.rjl=new RDjList(tdhp,tdhp.tl,mg.rjl);
	  tdhp.tl=d;
	}
        tdhp=d;
        dc++;
      }
      d=d.tl;
    } 
    if (tdhp.tl!=d && dc!=0) {
      mg.rjl=new RDjList(tdhp,tdhp.tl,mg.rjl);
      tdhp.tl=null;
    }
    me.update(dc,rval,mg);
    return (dc==0);
  }

  Cnsq subsumedDj(MGTP mg) {
    Cnsq d=this;
    while (d!=null) {
      if (d.hd.subsumed()) return null;
      d=d.tl;
    } 
    return this;
  }

}

class PDisj extends Disj {
  int dsize;
  PDisj(Term a) {hd=a;}
  PDisj(Term a, Cnsq t) {hd=a; tl=t;}
  PDisj(Term a, Cnsq t, int ds) {hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "PDisj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }

  Cnsq copy() {
    Cnsq cp=new PDisj(hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new PDisj(c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq t=this;
    Cnsq g=new GPDisj(t.hd.indexBV(mg));
    Cnsq gh=g;
    do {
      t=t.tl;
      if (t==null) break;
      g.tl=new GPDisj(t.hd.indexBV(mg));
      g=g.tl;
    } while (true);
    if (mg.pdlF==DList.NIL)
      mg.pdlL=mg.pdlF=new DList(dsize,gh);
    else {
      mg.pdlL.tl=new DList(dsize,gh);
      mg.pdlL=mg.pdlL.tl;
    }
  }
}

class NDisj extends Disj {
  int dsize;
  NDisj(Term a) {hd=a;}
  NDisj(Term a, Cnsq t) {hd=a; tl=t;}
  NDisj(Term a, Cnsq t, int ds) {hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "NDisj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }

  Cnsq copy() {
    Cnsq cp=new NDisj(hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new NDisj(c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq t=this;
    Cnsq g=new GNDisj(t.hd.indexBV(mg));
    Cnsq gh=g;
    do {
      t=t.tl;
      if (t==null) break;
      g.tl=new GNDisj(t.hd.indexBV(mg));
      g=g.tl;
    } while (true);
    if (mg.ndlF==DList.NIL)
      mg.ndlL=mg.ndlF=new DList(dsize,gh);
    else {
      mg.ndlL.tl=new DList(dsize,gh);
      mg.ndlL=mg.ndlL.tl;
    }
  }
}

class MDisj extends Disj {
  int dsize;
  MDisj(Term a) {hd=a;}
  MDisj(Term a, Cnsq t) {hd=a; tl=t;}
  MDisj(Term a, Cnsq t, int ds) {hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "MDisj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }

  Cnsq copy() {
    Cnsq cp=new MDisj(hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new MDisj(c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq t=this;
    Cnsq g=new GMDisj(t.hd.indexBV(mg));
    Cnsq gh=g;
    do {
      t=t.tl;
      if (t==null) break;
      g.tl=new GMDisj(t.hd.indexBV(mg));
      g=g.tl;
    } while (true);
    if (mg.mdlF==DList.NIL)
      mg.mdlL=mg.mdlF=new DList(dsize,gh);
    else {
      mg.mdlL.tl=new DList(dsize,gh);
      mg.mdlL=mg.mdlL.tl;
    }
  }
}

class GPDisj extends Disj {
  int dsize;
  GPDisj(Term a) {hd=a;}
  GPDisj(GTerm a, Cnsq n) {hd=a; tl=n;}
  GPDisj(GTerm a, Cnsq t, int ds) {hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "GPDisj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }

  Cnsq copy() {return this;}
  public void putBuf(MGTP mg) { // %%% public: PTV
    if (mg.pdlF==DList.NIL)
      mg.pdlL=mg.pdlF=new DList(dsize,this);
    else {
      mg.pdlL.tl=new DList(dsize,this);
      mg.pdlL=mg.pdlL.tl;
    }
  }
}

class GNDisj extends Disj {
  int dsize;
  GNDisj(Term a) {hd=a;}
  GNDisj(GTerm a, Cnsq n) {hd=a; tl=n;}
  GNDisj(GTerm a, Cnsq t, int ds) {hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "GNDisj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }

  Cnsq copy() {return this;}
  public void putBuf(MGTP mg) { // %%% public: PTV
    if (mg.ndlF==DList.NIL)
      mg.ndlL=mg.ndlF=new DList(dsize,this);
    else {
      mg.ndlL.tl=new DList(dsize,this);
      mg.ndlL=mg.ndlL.tl;
    }
  }
}

class GMDisj extends Disj {
  int dsize;
  GMDisj(Term a) {hd=a;}
  GMDisj(GTerm a, Cnsq n) {hd=a; tl=n;}
  GMDisj(GTerm a, Cnsq t, int ds) {hd=a; tl=t; dsize=ds;}

  public String toString() { 
    return "GMDisj:"+hd+clist(hd)+(tl==null ? "" : "; "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : "; "+tl);
  }

  Cnsq copy() {return this;}
  public void putBuf(MGTP mg) { // %%% public: PTV
    if (mg.mdlF==DList.NIL)
      mg.mdlL=mg.mdlF=new DList(dsize,this);
    else {
      mg.mdlL.tl=new DList(dsize,this);
      mg.mdlL=mg.mdlL.tl;
    }
  }
}

class Conj extends Cnsq {
  int dsize=1;
  Conj() {}
  Conj(Term a) {hd=a;}
  Conj(Term a, Cnsq n) {hd=a; tl=n;}

  public String toString() { 
    return "Conj:"+hd+clist(hd)+(tl==null ? "" : ", "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : ", "+tl);
  }

  Cnsq copy() {
    Cnsq cp=new Conj(hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new Conj(c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq c=this;
    while (c!=null) {
      GTerm t=c.hd.indexBV(mg);
      //Counter.usubs++;
      if (t.notsubsumed_ac(mg)) {
        //Counter.usubspass++;
        if (mg.unitF==null) mg.unitL=mg.unitF=new UList(t);
        else {mg.unitL.tl=new UList(t); mg.unitL=mg.unitL.tl;}
      }
      c=c.tl;
    }
  }
}

class GConj extends Conj {
  GConj(Term a) {hd=a;}
  GConj(GTerm a, Cnsq n) {hd=a; tl=n;}

  public String toString() { 
    return "GConj:"+hd+clist(hd)+(tl==null ? "" : ", "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : ", "+tl);
  }

  Cnsq copy() {return this;}

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq c=this;
    while (c!=null) {
      //Counter.usubs++;
      if (c.hd.notsubsumed_ac(mg)) {
        //Counter.usubspass++;
        if (mg.unitF==null) mg.unitL=mg.unitF=new UList(c.hd);
        else {mg.unitL.tl=new UList(c.hd); mg.unitL=mg.unitL.tl;}
      }
      c=c.tl;
    }
  }
}

class Unit extends Conj {
  Unit() {}
  Unit(Term a) {hd=a;}
  public String toString() {return "Unit:"+hd+clist(hd);}
  //  public String toString() {return hd+clist(hd);}
  Cnsq copy() {return new Unit(hd);}
  public void putBuf(MGTP mg) { // %%% public: PTV
    Term a=hd.indexBV(mg);
    //Counter.usubs++;
    if (a.notsubsumed_ac(mg)) {
      //Counter.usubspass++;
      if (mg.unitF==null) mg.unitL=mg.unitF=new UList(a);
      else {mg.unitL.tl=new UList(a); mg.unitL=mg.unitL.tl;}
    }
  }
}

class GUnit extends Unit {
  GUnit(GTerm a) {hd=a;}
  //  public String toString() {return "GUnit:"+hd+clist(hd);}
  public String toString() {return hd+clist(hd);}
  Cnsq copy() {return this;}
  public void putBuf(MGTP mg) { // %%% public: PTV
    //Counter.usubs++;
    if (hd.notsubsumed_ac(mg)) {
      //Counter.usubspass++;
      if (mg.unitF==null) mg.unitL=mg.unitF=new UList(hd);
      else {mg.unitL.tl=new UList(hd); mg.unitL=mg.unitL.tl;}
    }
  }
}

class DomConj extends Conj {
  DomConj() {}
  DomConj(Term a) {hd=a;}
  DomConj(Term a, Cnsq n) {hd=a; tl=n;}
  public String toString() { 
    return "DomConj:"+hd+clist(hd)+(tl==null ? "" : ", "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : ", "+tl);
  }

  Cnsq copy() {
    Cnsq cp=new DomConj(hd); Cnsq t=cp; Cnsq c=tl;
    while (c!=null) {t.tl=new DomConj(c.hd); t=t.tl; c=c.tl;}
    return cp;
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq c=this;
    while (c!=null) {
      Term t=(c.hd.indexBV(mg));
      //Counter.usubs++;
      if (t.notsubsumed_ac(mg)) {
	//Counter.usubspass++;
        if (mg.domsF==null) mg.domsL=mg.domsF=new UList(t);
        else {mg.domsL.tl=new UList(t); mg.domsL=mg.domsL.tl;}
      }
      c=c.tl;
    }
  }
}

class GDomConj extends DomConj {
  GDomConj(Term a) {hd=a;}
  GDomConj(GTerm a) {hd=a;}
  GDomConj(GTerm a, Cnsq n) {hd=a; tl=n;}
  public String toString() { 
    return "GDomConj:"+hd+clist(hd)+(tl==null ? "" : ", "+tl);
    //    return hd+clist(hd)+(tl==null ? "" : ", "+tl);
  }

  Cnsq copy() {return this;}

  public void putBuf(MGTP mg) { // %%% public: PTV
    Cnsq c=this;
    while (c!=null) {
      //Counter.usubs++;
      if (c.hd.notsubsumed_ac(mg)) {
	//Counter.usubspass++;
        if (mg.domsF==null) mg.domsL=mg.domsF=new UList(c.hd);
        else {mg.domsL.tl=new UList(c.hd); mg.domsL=mg.domsL.tl;}
      }
      c=c.tl;
    }
  }
}

class CLCnsq extends Cnsq {
  Clause hd; CLCnsq tl;
  CLCnsq() {}

  public String toString() { 
    String s="CLCnsq:["; CLCnsq c=this;
    //    String s="["; CLCnsq c=this;
    while (c.tl!=null) {s+=c.hd.id+","; c=c.tl;}
    return s+c.hd.id+"]";
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    CLCnsq c=this;
    while (c!=null) {
      c.hd.cjm(null);
      if (mg.closed) return;
      c=c.tl;
    }
  }
}

class SLCnsq extends Cnsq {
  Clause trueCl,falseCl; int sel;
  SLCnsq() {}

  public String toString() { 
    return "SLCnsq:"+"["+trueCl.id+";"+falseCl.id+"]";
    //    return "["+trueCl.id+";"+falseCl.id+"]";
  }

  public void putBuf(MGTP mg) { // %%% public: PTV
    switch (sel) {
    case 1: trueCl.cjm(null); return;
    case -1: falseCl.cjm(null); return;
    }
  }
}

class RDjList {
  public static RDjList NIL=new RDjList();
  Cnsq target; Cnsq oldtl; RDjList tl;
  RDjList() {}
  RDjList(Cnsq t, Cnsq o) {target=t; oldtl=o; tl=NIL;}
  RDjList(Cnsq t, Cnsq o, RDjList l) {target=t; oldtl=o; tl=l;}
  public String toString() {
    RDjList r=this; String s="";
    while (r!=NIL) {
      s+="RDjList[("+r.target.hd+")'s old tl = "+r.oldtl+"]\n";
      r=r.tl;
    }
    return s;
  }
  void restore() {
    RDjList d=this;
    while (d!=NIL) {d.target.tl=d.oldtl; d=d.tl;}
  }
}

// eof
