/**
 * ProveT.java 12-Apr-2000
 * Copyright (c) 1997-2000 Kyushu University
 **/

package ptv;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class ProveT extends Thread {
  public PTVisualizer ptv;
  String[] args;
  public Prove pv;
  public GTCount gtc;
  GT cur;
  boolean flag;

  public ProveT(PTVisualizer ptvis,String[] a) {ptv=ptvis;args=a;}

  public void run(){

    //ptv.readf_txt.setEnabled(false);
    ptv.readf_button.setEnabled(false);
    ptv.run=true;
    ptv.run_button.setEnabled(false);

    //System.out.println("new Prove");

    pv=new Prove(args,ptv.ptc,this);
    pv.setPriority(MIN_PRIORITY);
    ptv.susp_button.setEnabled(true);
    ptv.quit_button.setEnabled(true); // ###

    if (ptv.infengine=='m') {
      //System.out.println("mgtp selected");
      ptv.mgtp=pv.init_mgtp();
    }
    else if (ptv.infengine=='s') {
      //System.out.println("mgtpCS selected");
      ptv.mgtp=pv.init_mgtpCS();
    }
    else if (ptv.infengine=='c') {
      //System.out.println("mm-mchk selected");
      ptv.mgtp=pv.init_mchk();
    }
    /*
    else if (ptv.infengine=='r') {
      //System.out.println("mm-rcmp selected");
      ptv.mgtp=pv.init_rcmp();
    }
    */
    else if (ptv.infengine=='l') {
      //System.out.println("mm-rcmp32l selected");
      ptv.mgtp=pv.init_rcmp32l();
    }
    else {
      System.out.println("No such engine");
    }

    // Simple execution (Display disabled)  

    if (ptv.ptc.execProve_mode) {

      ptv.susp_button.setEnabled(false); // ###

      ptv.ptc.exec = new Exec(ptv);
      pv.start();

      ptv.ptc.exec.execProve();
      // exec end

      if (ptv.stwindow!=null) ptv.stwindow.displaystatusExec(); // %%%

      //      ptv.susp_button.setEnabled(false);
      ptv.quit_button.setEnabled(false); // ###
      ptv.run_button.setEnabled(true);

      //ptv.readf_txt.setEnabled(true);
      ptv.readf_button.setEnabled(true);
      ptv.run=false;

      pv=null;      // ###
      ptv.pt=null;  // ###

      //System.out.println("ProveT stopped in execProve");
      stop();

      return;
    }
    
    // Proof tree visualization (Display enabled)  

    //System.out.println("new GTCount disp_mode="+ptv.disp_mode);
    gtc=new GTCount(0,ptv.ptc,pv); // ###

    ptv.ptc.gtc=gtc; // ###
    //
    pv.set_ptvenv(ptv.mgtp); // %%%
    ptv.mgtp.set_pt_top(ptv.mgtp); // %%%

    ptv.ptc.zoomReset();

    ptv.ptc.coordinate_offScr(ptv.rootGT);
    pv.start();

    flag=true;
    cur=null;
    ptv.rootGT.redraw_flag=false;

    // Catch a DispModeException indicating that display mode has been 
    // changed while running, and re-display a PT in the specified mode.
    while (flag) {

      ptv.ptc.drwc=0; // %%%
      if (ptv.disp_mode=='t') {
	try {
	  ptv.rootGT.step=
	    (float)((ptv.cvw_height-ptv.ptc.top_margin-ptv.ptc.bot_margin)/
		    (ptv.max_gene+1.0)); 
	  ptv.rootGT.position_calc(ptv.ptc.sid_margin,
				   ptv.cvw_width-ptv.ptc.sid_margin*2,
				   ptv.cvw_height,ptv.ptc,cur);
	  flag=false;
	
	} catch(DispModeException e) {
	  //System.out.println("DispModeException occurred in ProveT (t)");
	  cur=e.gt;
	  ptv.ptc.coordinate_offScr(ptv.rootGT);
	  ptv.dspMenu.setEnabled(false);
	}
	catch(OutOfMemoryError e) {
	  System.out.println("OutOfMemoryError occurred in ProveT (t)");
	  flag=false;
	  break;
	}
	catch(Exception e) {
	  System.out.println("Exception occurred in ProveT (t)");
	  flag=false;
	  break;
	}
      } 
      else if (ptv.disp_mode=='r') {
	try {
	  if (ptv.cvw_height<ptv.cvw_width) {
	    ptv.rootGT.step=
	      (float)((ptv.cvw_height/2.0-ptv.ptc.top_margin)/
		      (ptv.max_gene+1.0));
	    ptv.rootGT.radial_position_calc(0,(float)Math.PI*2,
					    (int)(ptv.cvw_height/2.0),
					    ptv.ptc,cur);
	    }
	  else {
	    ptv.rootGT.step=
	      (float)((ptv.cvw_width/2.0-ptv.ptc.top_margin)/
		      (ptv.max_gene+1.0));
	    ptv.rootGT.radial_position_calc(0,(float)Math.PI*2,
					    (int)(ptv.cvw_width/2.0),
					    ptv.ptc,cur);
	  }
	  flag=false;
	} catch(DispModeException e) {
	  //System.out.println("DispModeException occurred in ProveT (r)");
	  cur=e.gt;
	  ptv.ptc.coordinate_offScr(ptv.rootGT);
	  ptv.dspMenu.setEnabled(false);
	}
	catch(OutOfMemoryError e) {
	  System.out.println("OutOfMemoryError occurred in ProveT (t)");
	  flag=false;
	  break;
	}
	catch(Exception e) {
	  System.out.println("Exception occurred in ProveT (t)");
	  flag=false;
	  break;
	}
      } 
      else if (ptv.disp_mode=='l') {
	try {
	  if (ptv.cvw_height<ptv.cvw_width) {
	    ptv.rootGT.step=
	      (float)((ptv.cvw_height/2.0-ptv.ptc.top_margin)/
		      (ptv.max_gene+1.0));
	    ptv.rootGT.rad_local_position_calc(0,(float)Math.PI*2,
					       (int)(ptv.cvw_height/2.0),
					       ptv.ptc,cur);
	    } 
	  else {
	    ptv.rootGT.step=
	      (float)((ptv.cvw_width/2.0-ptv.ptc.top_margin)/
		      (ptv.max_gene+1.0));
	    ptv.rootGT.rad_local_position_calc(0,(float)Math.PI*2,
					       (int)(ptv.cvw_width/2.0),
					       ptv.ptc,cur);
	  }
	  flag=false;
	} catch (DispModeException e) {
	  //System.out.println("DispModeException occurred in ProveT (l)");
	  cur=e.gt;
	  ptv.ptc.coordinate_offScr(ptv.rootGT);
	  ptv.dspMenu.setEnabled(false);
	}
	catch(OutOfMemoryError e) {
	  System.out.println("OutOfMemoryError occurred in ProveT (t)");
	  flag=false;
	  break;
	}
	catch(Exception e) {
	  System.out.println("Exception occurred in ProveT (t)");
	  flag=false;
	  break;
	}
      }
    }
    //    ptv.ptc.og.dispose();
    //System.out.println("proof end");

    pv.stop();

    if (ptv.stwindow!=null) ptv.stwindow.displaystatus(); // %%%
    //else  System.out.println("stwindow not alive");

    ptv.treeMenu.setEnabled(false);
    if (ptv.tree_mode=='w') {
      ptv.dspMenu.setEnabled(false);

      ptv.ptc.coordinate_offScr(ptv.rootGT);
      ptv.rootGT.leaf_calc(); 

      ptv.ptc.drwc=0; // %%%
      if (ptv.disp_mode=='t') {
	ptv.rootGT.step
	  =(float)((ptv.cvw_height-ptv.ptc.top_margin-ptv.ptc.bot_margin)/
				 (ptv.max_gene+1.0)); 

	ptv.rootGT.weighted_offdraw(ptv.ptc.sid_margin,
				    ptv.rootGT.ds,
				    ptv.cvw_width-ptv.ptc.sid_margin*2,
				    ptv.cvw_width-ptv.ptc.sid_margin*2,
				    ptv.ptc);
      }
      else if (ptv.disp_mode=='r') {
	if (ptv.cvw_height<ptv.cvw_width) 
	  ptv.rootGT.step=
	    (float)((ptv.cvw_height/2.0-ptv.ptc.top_margin)/
		    (ptv.max_gene+1.0));
	else ptv.rootGT.step=
	       (float)((ptv.cvw_width/2.0-ptv.ptc.top_margin)/
		       (ptv.max_gene+1.0));

	ptv.rootGT.r_weighted_offdraw(0,ptv.rootGT.ds,
				      (float)Math.PI*2,
				      (float)Math.PI*2,
				      ptv.ptc);
      }
      else if (ptv.disp_mode=='l') {
	if (ptv.cvw_height<ptv.cvw_width) 
	  ptv.rootGT.step=
	    (float)((ptv.cvw_height/2.0-ptv.ptc.top_margin)/
		    (ptv.max_gene+1.0));
	else ptv.rootGT.step=
	       (float)((ptv.cvw_width/2.0-ptv.ptc.top_margin)/
		       (ptv.max_gene+1.0));

	ptv.rootGT.r_local_weighted_offdraw(0,ptv.rootGT.ds,
					    (float)Math.PI*2,
					    (float)Math.PI*2,
					    ptv.ptc);
      }
      ptv.dspMenu.setEnabled(true);
    }

    ptv.treeMenu.setEnabled(true);
    ptv.ptc.repaint();
    ptv.susp_button.setEnabled(false);
    ptv.quit_button.setEnabled(false); // ###
    ptv.run_button.setEnabled(true);

    //ptv.readf_txt.setEnabled(true);
    ptv.readf_button.setEnabled(true);
    ptv.run=false;
    ptv.ptc.zoom_redraw=false;

    pv=null;      // ###
    ptv.pt=null;  // ###

    //System.out.println("ProveT stopped in normal Dspmode");
    stop();
  }
}


